Attribute VB_Name = "Game_002_MAIN"
Option Explicit

'hier startet und endet das Prog
Public Sub Main()

    Init_Starfight
    Main_Loop
    ShutDown_Starfight

End Sub

'hier wird das Spiel initialisiert (Surfaces, Sounds laden und Variablen initialisieren)
Private Sub Init_Starfight()
    
    Dim n       As Long
    
    Randomize
    
    g_Running = True
    
    'Form laden
    Load frmMain
    
    'Engine hochfahren
    Init_GraFX
    
    'Grafik-Engine hochfahren
    Init_GraFX_GRAPHIC frmMain, X_RES, Y_RES, COL_DEPTH, DISP_MODE_FULLSCREEN
    
    'Sound-Engine hochfahren
    Init_GraFX_SOUND frmMain
    
    'Surfaces laden
    Load_Surf App.Path & "\pics\ship_001.bmp", g_SurfShip, 0
    
    Load_Surf App.Path & "\pics\torpedo.bmp", g_SurfTorp, 0
    
    For n = 1 To 4
        Load_Surf App.Path & "\pics\planet_" & Format(n, "000") & ".bmp", g_SurfPlanet(n), 0
    Next
    
    For n = 1 To 3
        Load_Surf App.Path & "\pics\asteroid_" & Format(n, "000") & ".bmp", g_SurfAsteroid(n), 0
    Next
    
    For n = 1 To 3
        Load_Surf App.Path & "\pics\warpstar_" & Format(n, "000") & ".bmp", g_SurfStar(n), 0
    Next
    
    'Texturen laden
    For n = 1 To 2
        CreateTexture App.Path & "\pics\effect" & Format(n, "00") & ".bmp", g_EffectTexture(n)
    Next n
    
    CreateTexture App.Path & "\pics\light.bmp", g_LightTexture
    
    'Schrift laden
    Load_Font App.Path & "\pics\font.fnt", App.Path & "\pics\font.bmp", g_Font, 2016
            
    'Sounds laden
    Load_SBuf App.Path & "\sounds\explosion.wav", g_SBufExplo
    
    Load_SBuf App.Path & "\sounds\photon.wav", g_SBufTorp
    
    'HintergrundSterne initialisieren
    For n = 1 To NUM_BACKSTARS
        Set_BackStar g_BackStar(n)
    Next
    
    'Sterne initialisieren
    For n = 1 To NUM_STARS
        Set_Star g_Star(n)
    Next
        
    'Player initialisieren
    Recover_Player
    
    'Planeten initialisieren
    Set_Planet
    
    'Torpedos initialisieren
    For n = 1 To NUM_TORPS
        Destroy_Torp g_Torp(n)
    Next
    
    'Asteroiden initialisieren
    For n = 1 To NUM_ASTEROIDS
        Set_Asteroid g_Asteroid(n)
    Next
    
    'Effektegrundlagen herstellen
    InitEffects
    
    'Lichteffekte initialisieren
    For n = 1 To NUM_TORPS
        With g_TorpLight(n)
            .Radius = 200
            .AttenuationSpeed = 0
            .VDeceleration = 1
            .Color = SetColor(255, 50, 0)
            .Intensity = 3
        End With
    Next
    
    'Torpedoexplosionen initialisieren
    For n = 1 To NUM_TORPS
        With g_TorpExplosion(n)
            .ParticleCount = 30
            
            ReDim .Particle(1 To .ParticleCount)
            
            .SpreadRange = PI * 2
            .SpreadRangeOffset = 0
        
            .StartMinRadius = 0
            .EndRadius = 20
                   
            .VDeceleration = 1
                   
            .ColorMode = START_AND_INV_COLOR
            .StartColor = SetColor(50, 100, 25)
            .InvColor = SetColor(210, 210, 210)
            
            
            .AttenuationStartRange = 0.3
            .AttenuationSpeed = 0.01
            
            .MinParticleRadius = 0.2
            .MaxParticleRadius = 1.2
            
            .MinParticleRot = -0.1
            .MaxParticleRot = 0.1

        End With
    Next n
    
    
    For n = 1 To NUM_ASTEROIDS
        'Asteroidenexplosionen initialisieren
        With g_BigExplosion(n)
            .ParticleCount = 100
            ReDim .Particle(1 To .ParticleCount)
            
            .SpreadRange = PI * 2
            .SpreadRangeOffset = 0
        
            .StartMinRadius = -20
            .EndRadius = 150
            
            .VDivIncreasing = True
            .VMaxIncreasing = 3
            .VMinIncreasing = 0.2
            
            .VDeceleration = 0.95
            .VDecelThreshold = 0.35
                    
            .ColorMode = ONLY_START_COLOR
            .StartColor = SetColor(200, 150, 100)
            
            .AttenuationStartRange = 0.3
            .AttenuationSpeed = 0.01
            
            .MinParticleRadius = 0.3
            .MaxParticleRadius = 2.3
        End With
    
        'Asteroidenschweif initialisieren
        With g_Smoke(n)
            .ParticleCount = 20
            ReDim .Particle(1 To .ParticleCount)
            
            .SpreadRange = 0.5
            .SpreadRangeOffset = -.SpreadRange / 2
            
            .StartMinRadius = 0
            .EndRadius = 500
                   
            .VDeceleration = 1
                   
            .ColorMode = ONLY_START_COLOR
            .StartColor = SetColor(110, 110, 100)
            
            .AttenuationStartRange = 0.1
            .AttenuationSpeed = 0.005
            
            .MinParticleRadius = 0.5
            .MaxParticleRadius = 3.5
            
            .InfiniteSpread = True
            
            .MinParticleRot = -0.1
            .MaxParticleRot = 0.1
        End With
        
        SetEffect g_Smoke(n), 0, -50
        
    Next n
    
    'WellenEngine und eigene Schockwelle initialisieren
    InitWaveNet App.Path & "\pics\e256.bmp"
    With g_Wave(1)
        .WaveCount = 1
        
        .c = 0.4
        
        .Amplitude = 3
        
        .WaveLength = 5
    End With
    
    With g_ExplosionWave
        .ParticleCount = 500
        ReDim .Particle(1 To .ParticleCount)
        
        .SpreadRange = PI * 2
        .SpreadRangeOffset = 0
    
        .StartMinRadius = 0
        .EndRadius = 500
        
        .VDeceleration = 0.97
        .VDecelThreshold = 0.4
                
        .ColorMode = ONLY_START_COLOR
        .StartColor = SetColor(100, 120, 200)
        
        .AttenuationStartRange = 0.3
        .AttenuationSpeed = 0.004
        
        .MinParticleRadius = 0.3
        .MaxParticleRadius = 3.2
        
        .MinParticleRot = -0.1
        .MaxParticleRot = 0.1
    End With
    
    With g_ExploLight       'Explosionslicht fr das Schiff
        .Radius = 300
        .AttenuationSpeed = 0.003
        .VDeceleration = 1
        .Color = SetColor(0, 150, 250)
        .Intensity = 3
    End With
    
    SetCam      'D3DEinstellungen setzen fr EffektEngine
    
End Sub

'hier wird das Spiel beendet
Private Sub ShutDown_Starfight()
    
    Dim n       As Long
    
    'Surfaces lschen
    Unload_Surf g_SurfShip
    
    Unload_Surf g_SurfTorp
    
    For n = 1 To 4
        Unload_Surf g_SurfPlanet(n)
    Next
    
    For n = 1 To 3
        Unload_Surf g_SurfAsteroid(n)
    Next
    
    For n = 1 To 3
        Unload_Surf g_SurfStar(n)
    Next
    
    Unload_Font g_Font
    
    'Sounds lschen
    Unload_SBuf g_SBufExplo
    
    Unload_SBuf g_SBufTorp
    
    'Sound-Engine runterfahren
    Unload_GraFX_SOUND frmMain
    
    'Grafik-Engine runterfahren
    Unload_GraFX_GRAPHIC frmMain
    
    'Engine runterfahren
    Unload_GraFX
    
    'Prog beenden
    Unload frmMain
    End
    
End Sub

'Hauptschleife des Spiels
Private Sub Main_Loop()
    
    Do While g_Running
        
        'Tastatur-, MausStatus abfragen
        Acquire_Input
        
        'Beenden mit Escape
        If GetActKeyState(VK_ESCAPE) Then g_Running = False
        
        'Recover
        If GetActKeyState(VK_BACKSPACE) Then Recover_Player
        
        'HintergrundSterne bewegen
        Move_BackStars
        
        'Sterne bewegen
        Move_Stars
        
        'Spieler steuern
        Control_Player
                
        'Planeten bewegen
        Move_Planet
        
        'Torpedos bewegen
        Move_Torps
        
        'Asteroiden bewegen
        Move_Asteroids
        
        'Kollisionsabfrage
        Verify_Collison
                
        'Bildschirm lschen
        FillRect SetRect(0, 0, X_RES, Y_RES), 0
        
        'Hintergrundsterne zeichnen
        Draw_BackStars
        
        'Sterne zeichnen
        Draw_Stars
        
        'Spieler zeichnen
        If g_Player.Draw Then Blit_Surf g_Player.X, g_Player.Y, g_SurfShip
        
        'Planeten zeichnen
        Draw_Planet
        
        'Torpedos zeichnen
        Draw_Torps
        
        'AsteroidenSchweif zeichnen
        Draw_AsteroidTails
        
        'Asteroiden zeichnen
        Draw_Asteroids
        
        'Effekte zeichnen
        Draw_Effects
        
        'FPS anzeigen
        Blit_Text 2, 2, Int(GetFPS()), g_Font
                
        'GrafikAusgabe
        Flip True
        
    Loop
    
End Sub
