Attribute VB_Name = "Game_003_GAME"
Option Explicit

'Player recovern
Public Sub Recover_Player()
    
    With g_Player
        If .Draw Then Exit Sub
        
        .Draw = True
        .X = 0
        .Y = 0
        .MovX = 0
        .MovY = 0
        .Shields = 100
    End With

End Sub

'Player zerstren
Public Sub Destroy_Player()
    
    With g_Player
        .Draw = False
        
        'Sound abspielen
        Stop_SBuf g_SBufExplo
        Reset_SBuf g_SBufExplo
        Play_SBuf g_SBufExplo
        
        'Explosion startem
        SetEffect g_ExplosionWave, .X + g_SurfShip.Width / 2, .Y + g_SurfShip.Height / 2
        SetWaveNet g_Wave(1), .X + g_SurfShip.Width / 2, .Y + g_SurfShip.Height / 2
        SetLight g_ExploLight, 0, .X + g_SurfShip.Width / 2, .Y + g_SurfShip.Height / 2
    End With
    
End Sub

'Player steuern
Public Sub Control_Player()
    
    Dim h_Dist      As Single
    Dim h_XDist     As Single
    Dim h_YDist     As Single
    Dim h_dmy       As Single
                    
    If Not g_Player.Draw Then Exit Sub
                    
    With g_Player
        'Steuerung
        If GetActKeyState(VK_LEFT) Then .MovX = .MovX - PLAYER_SPEED
        If GetActKeyState(VK_RIGHT) Then .MovX = .MovX + PLAYER_SPEED
        If GetActKeyState(VK_UP) Then .MovY = .MovY - PLAYER_SPEED
        If GetActKeyState(VK_DOWN) Then .MovY = .MovY + PLAYER_SPEED
        
        'Anziehung des Planeten
        With g_Planet
            If .Draw Then
                h_XDist = .X + g_SurfPlanet(.PType).Width * 0.5 - (g_Player.X + g_SurfShip.Width * 0.5)
                h_YDist = Y_RES - (g_Player.Y + g_SurfShip.Height * 0.5)
                h_Dist = PythA(h_XDist, h_YDist)
                
                If h_Dist < 1 Then h_Dist = 1
                h_dmy = PLANET_GRAV / (h_Dist * h_Dist * 0.25)
                
                g_Player.MovX = g_Player.MovX + h_XDist * h_dmy
                g_Player.MovY = g_Player.MovY + h_YDist * h_dmy
            End If
        End With
        
        'bewegen
        .X = .X + AV(.MovX)
        .Y = .Y + AV(.MovY)
        .MovX = 0
        .MovY = 0
        
        'Randbegrenzung
        If .X < 0 Then .X = 0
        If .Y < 0 Then .Y = 0
        If .X > X_RES - g_SurfShip.Width Then .X = X_RES - g_SurfShip.Width
        If .Y > Y_RES - g_SurfShip.Height Then .Y = Y_RES - g_SurfShip.Height
    End With
    
End Sub

'Kollisionsabfrage
Public Sub Verify_Collison()
    
    Dim n           As Long
    Dim m           As Long
        
    If g_Player.Draw Then
        'Kollision mit Asteroiden
        For n = 1 To NUM_ASTEROIDS
            With g_Asteroid(n)
                If .Draw Then
                    If RectColl(g_Player.X, g_Player.Y, g_SurfShip.Width, g_SurfShip.Height, .X, .Y, g_SurfAsteroid(.AType).Width, g_SurfAsteroid(.AType).Height) Then
                        g_Player.Shields = g_Player.Shields - 10
                        Destroy_Asteroid g_Asteroid(n)
                        If g_Player.Shields < 0 Then
                            Destroy_Player
                            Exit Sub
                        End If
                    End If
                End If
            End With
        Next
    End If
    
    If g_Player.Draw Then
        'Kollision mit Planeten
        With g_Planet
            If RadiusColl(g_Player.X + g_SurfShip.Width * 0.5, g_Player.Y + g_SurfShip.Height * 0.5, g_SurfShip.Height * 0.5, .X + g_SurfPlanet(.PType).Width * 0.5, Y_RES, g_SurfPlanet(.PType).Width * 0.5) Then Destroy_Player
        End With
    End If
    
    'TorpedoKollision
    For n = 1 To NUM_TORPS
        With g_Torp(n)
            If .Draw Then
                
                'Kollision mit rechtem Rand
                If .X > X_RES - .Anim.FrameWidth Then
                    Destroy_Torp g_Torp(n)
                
                'Kollision mit Asteroiden
                Else
                    For m = 1 To NUM_ASTEROIDS
                        If g_Asteroid(m).Draw Then
                            If RectColl(.X, .Y, .Anim.FrameWidth, g_SurfTorp.Height, g_Asteroid(m).X, g_Asteroid(m).Y, g_SurfAsteroid(g_Asteroid(m).AType).Width, g_SurfAsteroid(g_Asteroid(m).AType).Height) Then
                                Destroy_Torp g_Torp(n)
                                Destroy_Asteroid g_Asteroid(m)
                            End If
                        End If
                    Next
                End If
            End If
        End With
    Next
    
End Sub

'zerstrt einen Torpedo
Public Sub Destroy_Torp(ByRef Torp As TTorp)
    Dim n As Long
    
    With Torp
        For n = 1 To NUM_TORPS
            If g_TorpLight(n).X = .X And g_TorpLight(n).Y = .Y Then
                g_TorpLight(n).Draw = False
                Exit For
            End If
        Next
        
        .Draw = False
        
        g_TorpExploCount = g_TorpExploCount + 1
        If g_TorpExploCount > NUM_TORPS Then g_TorpExploCount = 1
                
        SetEffect g_TorpExplosion(g_TorpExploCount), .X, .Y
    End With
    
End Sub

'Torpedo abschieen (registriert im KeyDown-Ereignis vom Input-Modul)
Public Sub Fire_Torpedo()
    
    With g_Player
        If Not .Draw Then Exit Sub
        
        'Sound abspielen
        Stop_SBuf g_SBufTorp
        Reset_SBuf g_SBufTorp
        Play_SBuf g_SBufTorp
    
        .TorpCount = .TorpCount + 1
        If .TorpCount > NUM_TORPS Then .TorpCount = 1
        If .TorpCount < 1 Then .TorpCount = 1
        
        With g_Torp(.TorpCount)
            .Draw = True
            Init_Anim g_SurfTorp, .Anim, 16
            .X = g_Player.X + 60
            .Y = g_Player.Y - g_SurfTorp.Height * 0.25
            
            SetLight g_TorpLight(g_Player.TorpCount), 0, .X, .Y
        End With
       
    End With
    
End Sub

'Torpedos bewegen
Public Sub Move_Torps()
    
    Dim n           As Long
    
    For n = 1 To NUM_TORPS
        With g_Torp(n)
            If .Draw Then
                .X = .X + AV(8)
                g_TorpLight(n).X = .X
            End If
        End With
    Next
    
End Sub

'Torpedos zeichnen
Public Sub Draw_Torps()
    
    Dim n       As Long
    
    For n = 1 To NUM_TORPS
        With g_Torp(n)
            If .Draw Then
                Proceed_Anim .Anim, AV(0.2)      'Animation
                Blit_Anim .X, .Y, g_SurfTorp, .Anim
            End If
        End With
    Next
    
End Sub

'Planeten neu hinsetzen
Public Sub Set_Planet()
    
    With g_Planet
        .Draw = False
        .PType = Int(Rnd * 4) + 1
        SetEvent .CreateEvent, Int(Rnd * 4000) + 4000, 0
        .X = X_RES
    End With
    
End Sub

'Planeten bewegen
Public Sub Move_Planet()
    
    With g_Planet
        If .Draw Then
            .X = .X - AV(2)
            If .X < -g_SurfPlanet(.PType).Width Then Set_Planet
        ElseIf GetEventStatus(.CreateEvent) Then
            .Draw = True
            SetEvent .CreateEvent, -1
        End If
    End With
    
End Sub

'Planeten zeichnen
Public Sub Draw_Planet()
    
    With g_Planet
        If .Draw Then Blit_Surf .X, Y_RES - g_SurfPlanet(.PType).Height, g_SurfPlanet(.PType)
    End With
    
End Sub

'Stern neu hinsetzen
Public Sub Set_Star(ByRef Star As TStar)
    
    With Star
        .Draw = False
        .SType = Int(Rnd * 3) + 1
        SetEvent .CreateEvent, Int(Rnd * 1000) + 500, 0
        .MovX = -(Rnd * 3 + 4) * .SType * 0.5
        .X = X_RES
        .Y = Int(Rnd * (Y_RES - g_SurfStar(.SType).Height))
    End With
    
End Sub

'Sterne bewegen
Public Sub Move_Stars()
    
    Dim n       As Long
    
    For n = 1 To NUM_STARS
        With g_Star(n)
            If .Draw Then
                .X = .X + AV(.MovX)
                If .X < -g_SurfStar(.SType).Width Then Set_Star g_Star(n)
            ElseIf GetEventStatus(.CreateEvent) Then
                .Draw = True
                SetEvent .CreateEvent, -1
            End If
        End With
    Next
    
End Sub

'zeichnet alle Sterne
Public Sub Draw_Stars()

    Dim n       As Long
    
    For n = 1 To NUM_STARS
        With g_Star(n)
            If .Draw Then Blit_Surf .X, .Y, g_SurfStar(.SType)
        End With
    Next
    
End Sub

'setzt einen HintergrundStern
Public Sub Set_BackStar(ByRef BackStar As TBackStar)
    
    With BackStar
        .MovX = -Rnd * 2
        .X = X_RES + Rnd * X_RES
        .Y = Int(Rnd * (Y_RES - 1))
    End With
    
End Sub

'bewegt die Hintergrundsterne
Public Sub Move_BackStars()
    
    Dim n           As Long
    
    For n = 1 To NUM_BACKSTARS
        With g_BackStar(n)
            .X = .X + AV(.MovX)
            If .X < 0 Then Set_BackStar g_BackStar(n)
        End With
    Next
    
End Sub

'HintergrundSterne zeichnen
Public Sub Draw_BackStars()
    
    Dim n           As Long
    Dim ERect       As RECT
    Dim ESurfDesc   As DDSURFACEDESC2
    
    g_BackBuf.Lock ERect, ESurfDesc, DDLOCK_WRITEONLY, 0
        For n = 1 To NUM_BACKSTARS
            With g_BackStar(n)
                If .X < X_RES Then
                    g_BackBuf.SetLockedPixel .X, .Y, &HFFFF
                End If
            End With
        Next
    g_BackBuf.Unlock ERect
    
End Sub

'Asteroid neu hinsetzen
Public Sub Set_Asteroid(ByRef Asteroid As TAsteroid)
    
    With Asteroid
        .Draw = False
        .AType = Int(Rnd * 3) + 1
        SetEvent .CreateEvent, Int(Rnd * 1000) + 500, 0
        .MovX = -(Rnd * 1 + 5) * .AType * 0.5
        .X = X_RES
        .Y = Int(Rnd * (Y_RES - g_SurfAsteroid(.AType).Height))
    End With
    
End Sub

'Asteroid zerstren
Public Sub Destroy_Asteroid(ByRef Asteroid As TAsteroid)
    
    With Asteroid
    
        g_BigExploCount = g_BigExploCount + 1
        If g_BigExploCount > NUM_ASTEROIDS Then g_BigExploCount = 1
        
        SetEffect g_BigExplosion(g_BigExploCount), .X + g_SurfAsteroid(.AType).Width / 2, .Y + g_SurfAsteroid(.AType).Height / 2
        
        'Sound abspielen
        Stop_SBuf g_SBufExplo
        Reset_SBuf g_SBufExplo
        Play_SBuf g_SBufExplo

        Set_Asteroid Asteroid
        
    End With
    
End Sub

'Asteroiden bewegen
Public Sub Move_Asteroids()
    
    Dim n       As Long
    
    For n = 1 To NUM_ASTEROIDS
        With g_Asteroid(n)
            If .Draw Then
                .X = .X + AV(.MovX)
                If .X < -g_SurfAsteroid(.AType).Width Then Set_Asteroid g_Asteroid(n)
            ElseIf GetEventStatus(.CreateEvent) Then
                .Draw = True
                SetEvent .CreateEvent, -1
            End If
            
            g_Smoke(n).X = .X + g_SurfAsteroid(.AType).Width / 2
            g_Smoke(n).Y = .Y + g_SurfAsteroid(.AType).Height / 2
            
        End With
    Next
    
End Sub

'zeichnet alle Asteroiden
Public Sub Draw_Asteroids()

    Dim n       As Long
    
    For n = 1 To NUM_ASTEROIDS
        With g_Asteroid(n)
            If .Draw Then Blit_Surf .X, .Y, g_SurfAsteroid(.AType)
        End With
    Next
    
End Sub

'zeichnet fast alle Effekte
Public Sub Draw_Effects()

    Dim n       As Long
    
    For n = 1 To NUM_TORPS
        DrawLight g_TorpLight(n), g_LightTexture
    Next
    
    DrawLight g_ExploLight, g_LightTexture
    
    For n = 1 To NUM_TORPS
        If g_TorpExplosion(n).Draw Then
            DrawEffect g_TorpExplosion(n), g_EffectTexture(1)
        End If
    Next n
                          
    For n = 1 To NUM_ASTEROIDS
        If g_BigExplosion(n).Draw Then
            DrawEffect g_BigExplosion(n), g_EffectTexture(1)
        End If
    Next n
    
    If g_ExplosionWave.Draw Then
        DrawEffect g_ExplosionWave, g_EffectTexture(2)
    End If
    
    'Wellen
    MoveWaves g_Wave, 1, 1
    If AreWavesVisible(g_Wave, 1, 1) Then
      DrawWaveNet
    End If

End Sub

'zeichnet AsteroidenSchweife
Public Sub Draw_AsteroidTails()
    Dim n As Long
    
    For n = 1 To NUM_ASTEROIDS
        If g_Smoke(n).Draw Then
            DrawEffect g_Smoke(n), g_EffectTexture(2)
        End If
    Next n
End Sub
