Attribute VB_Name = "GraFX_002_MATH"
Option Explicit

'===API===

'fr Time-Counter
Private Declare Function QueryPerformanceFrequency Lib "kernel32" _
(ByRef Frequency As Currency) As Long

Private Declare Function QueryPerformanceCounter Lib "kernel32" _
(ByRef Counter As Currency) As Long


'===Typen===

Public Type TTimeEvent                                      'Zeit-Event
    StartTime                               As Long
    StartDelay                              As Long
    TimeOut                                 As Long
End Type


'===ffentliche Variablen

Public Const PI                             As Single = 3.14159
Public Const HPI                            As Single = 1.57079
Public Const TPI                            As Single = 6.28318


'===interne Variablen===

Private TimerFreq                           As Currency                 'Timer-Frequenz

'initialisiert die Mathe-Engine
Public Sub Init_GraFX_MATH()
        
    QueryPerformanceFrequency TimerFreq
        
End Sub

'Pythagoras (Addition)
Public Function PythA(ByVal a As Single, ByVal b As Single) As Single

    PythA = Sqr(a * a + b * b)

End Function

'Pythagoras (Subtraktion)
Public Function PythS(ByVal a As Single, ByVal b As Single) As Single

    PythS = Sqr(a * a - b * b)

End Function

'Pythagoras ohne Wurzel (Addtion)
Public Function CQuadA(ByVal a As Single, ByVal b As Single) As Single

    CQuadA = a * a + b * b

End Function

'Pythagoras ohne Wurzel (Subtraktion)
Public Function CQuadS(ByVal a As Single, ByVal b As Single) As Single

    CQuadS = a * a - b * b

End Function

'Rectangle-Kollision
Public Function RectColl(ByVal X1 As Long, ByVal Y1 As Long, ByVal Width1 As Integer, ByVal Height1 As Integer, ByVal X2 As Long, ByVal Y2 As Long, ByVal Width2 As Integer, ByVal Height2 As Integer) As Boolean

    RectColl = ((X1 + Width1 >= X2) And (X1 <= X2 + Width2) And (Y1 + Height1 >= Y2) And (Y1 <= Y2 + Height2))

End Function

'gibt zurck ob sich ein Objekt in einem Rectangle befindet
Public Function IsInRect(ByRef Rectangle As RECT, ByVal X As Long, ByVal Y As Long, ByVal Width As Integer, ByVal Height As Integer) As Boolean

    With Rectangle
        IsInRect = ((X + Width >= .Left) And (Y + Height >= .Top) And (X <= .Right) And (Y <= .Bottom))
    End With

End Function

'Radius Kollision
Public Function RadiusColl(ByVal MidX1 As Long, ByVal MidY1 As Long, ByVal r1 As Long, ByVal MidX2 As Long, ByVal MidY2 As Long, ByVal r2 As Long) As Boolean
    
    Dim a       As Long
    Dim b       As Long
    Dim Dist    As Long
    
    a = MidX2 - MidX1
    b = MidY2 - MidY1
    Dist = r1 + r2
    RadiusColl = (a * a + b * b <= Dist * Dist)
        
End Function

'Event initialisieren (TimeOut in ms)
Public Sub SetEvent(ByRef TimeEvent As TTimeEvent, ByVal StartDelay As Long, Optional ByVal TimeOut As Long = 0)

    With TimeEvent
        .StartTime = g_DX.TickCount
        .StartDelay = StartDelay
        .TimeOut = TimeOut
    End With

End Sub

'Event-Status abfragen
Public Function GetEventStatus(ByRef TimeEvent As TTimeEvent, Optional ByVal GameSpeedFact As Single = 1) As Boolean
    
    Dim SpeedFact       As Single
    
    With TimeEvent
        If .StartDelay >= 0 Then
            SpeedFact = 1 / GameSpeedFact
        
            If .TimeOut > 0 Then
                GetEventStatus = (g_DX.TickCount >= .StartTime + .StartDelay * SpeedFact And g_DX.TickCount <= .StartTime + (.StartDelay + .TimeOut) * SpeedFact)
            ElseIf .TimeOut = 0 Then
                GetEventStatus = (g_DX.TickCount >= .StartTime + .StartDelay * SpeedFact)
            End If
        Else
            GetEventStatus = False
        End If
    End With
    
End Function

'gibt einen Sekundenzhler mit 4 stelliger Genauigkeit zurck
Public Function GetSecCount() As Currency

    QueryPerformanceCounter GetSecCount
    GetSecCount = GetSecCount / TimerFreq

End Function
