Attribute VB_Name = "GraFX_004_INPUT"
Option Explicit

'===API===

Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Private Declare Function GetCursorPos Lib "user32" (ByRef lpPoint As POINTAPI) As Long


'===Typen===

Private Type POINTAPI
    X                                   As Long
    Y                                   As Long
End Type


'===Enums===

Public Enum EKeyConstants
    VK_BACKSPACE = 8
    VK_TAB = 9
    VK_RETURN = 13
    VK_SHIFT = &H10
    VK_ALT = 18
    VK_BREAK = 19
    VK_ESCAPE = 27
    VK_SPACE = 32
    VK_PRIOR = 33
    VK_NEXT = 34
    VK_END = 35
    VK_POS1 = 36
    VK_LEFT = 37
    VK_UP = 38
    VK_RIGHT = 39
    VK_DOWN = 40
    VK_INSERT = 45
    VK_DELETE = 46
    VK_0 = 48
    VK_1 = 49
    VK_2 = 50
    VK_3 = 51
    VK_4 = 52
    VK_5 = 53
    VK_6 = 54
    VK_7 = 55
    VK_8 = 56
    VK_9 = 57
    VK_A = 65
    VK_B = 66
    VK_C = 67
    VK_D = 68
    VK_E = 69
    VK_F = 70
    VK_G = 71
    VK_H = 72
    VK_I = 73
    VK_J = 74
    VK_K = 75
    VK_L = 76
    VK_M = 77
    VK_N = 78
    VK_O = 79
    VK_P = 80
    VK_Q = 81
    VK_R = 82
    VK_S = 83
    VK_T = 84
    VK_U = 85
    VK_V = 86
    VK_W = 87
    VK_X = 88
    VK_Y = 89
    VK_Z = 90
    VK_LWINDOW = 91
    VK_RWINDOW = 92
    VK_MENU = 93
    VK_NUM_0 = 96
    VK_NUM_1 = 97
    VK_NUM_2 = 98
    VK_NUM_3 = 99
    VK_NUM_4 = 100
    VK_NUM_5 = 101
    VK_NUM_6 = 102
    VK_NUM_7 = 103
    VK_NUM_8 = 104
    VK_NUM_9 = 105
    VK_NUM_MULTIPLY = 106
    VK_NUM_ADD = 107
    VK_NUM_SUBTRACT = 109
    VK_NUM_COMMA = 110
    VK_NUM_DIVIDE = 111
    VK_F1 = 112
    VK_F2 = 113
    VK_F3 = 114
    VK_F4 = 115
    VK_F5 = 116
    VK_F6 = 117
    VK_F7 = 118
    VK_F8 = 119
    VK_F9 = 120
    VK_F10 = 121
    VK_F11 = 122
    VK_F12 = 123
    VK_NUM_NUMLOCK = 144
    VK_SCROLLLOCK = 145
    VK_ = 168
    VK_ADD = 187
    VK_COMMA = 188
    VK_HYPHEN = 189
    VK_POINT = 190
    VK_RHOMBUS = 191
    VK_ = 192
    VK_ = 219
    VK_EQUALS = 220
    VK_ACCENT = 221
    VK_ = 222
    VK_SIZECOMPARISON = 226
    VK_MOUSE_LEFT = &H1
    VK_MOUSE_MID = &H4
    VK_MOUSE_RIGHT = &H2
    VK_CONTROL = 17
End Enum


'===interne Variablen===

Private MouseX                          As Long
Private MouseY                          As Long
Private KeyState(1 To 255)              As Boolean
Private OldKeyState(1 To 255)           As Boolean
Private Const KEY_PUSHED                As Long = &H8000

'initialisiert die Input-Engine
Public Function Init_GraFX_INPUT()

    Dim n           As Long
    
    For n = 1 To 255
        OldKeyState(n) = False
    Next n

End Function

'holte alle Infos ber gedrchte Tasten der Maus und der Tastatur
Public Sub Acquire_Input()

    Dim h_MousePoint        As POINTAPI
    Dim h_State             As Long
    Dim n                   As Long
    Dim FileNum             As Integer
    
    'TastaturStatus ermitteln
    For n = 1 To 255
        KeyState(n) = CBool(GetAsyncKeyState(n) And KEY_PUSHED)
        
        If KeyState(n) And Not OldKeyState(n) Then KeyDown n
        If Not KeyState(n) And OldKeyState(n) Then KeyUp n
        
        OldKeyState(n) = KeyState(n)
    Next n
            
    'Mauskoordinaten
    GetCursorPos h_MousePoint
    MouseX = h_MousePoint.X
    MouseY = h_MousePoint.Y
    
    DoEvents
    
End Sub

'gibt MouseX zurck
Public Function GetMouseX() As Long

    GetMouseX = MouseX

End Function

'gibt MouseY zurck
Public Function GetMouseY() As Long
    
    GetMouseY = MouseY
    
End Function

'gibt den Status einer Taste zurck
Public Function GetActKeyState(ByVal Key As EKeyConstants) As Boolean
    
    GetActKeyState = KeyState(Key)

End Function

Private Sub KeyDown(ByVal Key As EKeyConstants)

    '---hier andere Prozeduren oder die ntigen Ereignisse eintragen---
    
End Sub

Private Sub KeyUp(ByVal Key As EKeyConstants)

    '---hier andere Prozeduren oder die ntigen Ereignisse eintragen---

End Sub
